% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vsfuk2012-data.R
\docType{data}
\name{vsfuk2012}
\alias{vsfuk2012}
\title{Vital Statistics of Fukuoka pref. from 2008 to 2012}
\format{A data frame with 72 rows and 17 variables}
\usage{
data(vsfuk2012)
}
\description{
A dataset containing vital statistics such as population, fertility rate
and mortality rate of 72 municipalities in Fukuoka prefecture, Japan
from 2008 to 2012. The variables are as follows:
}
\details{
\itemize{
   \item CityCode. code of the municipality
   \item CityName. name of the municipality
   \item Type. municipality type, City, Town, Village or Ward
   \item FertilityRate. fertility rate: number of births per 1,000 population
   \item MortalityRate. mortality rate: number of deaths per 1,000 population
   \item MR_male. mortality rate of male
   \item MR_female. mortality rate of female
   \item IMR. infant mortality rate: number of deaths per 1,000 births
   \item FDR_sp. spontaneous fetal death rate: number of deaths per 1,000 births
   \item FDR_artificial. artificial fetal death rate: number of deaths per 1,000 births
   \item MarriageRate. marriage rate: number of marriages per 1,000 population
   \item DivorceRate. divorce rate: number of divorces per 1,000 population
   \item TFR. total fertility rate: average number of children that would be born to a woman over her lifetime
   \item SMR_male. standardized mortality ratio of male
   \item SMR_female. standardized mortality ratio of female
   \item pop_male. male population
   \item pop_female. female population 
}
}
\references{
\url{http://www.e-stat.go.jp/SG1/estat/GL08020103.do?_toGL08020103_}
}
\keyword{datasets}
